#ifndef VisionExpert_h
#define VisionExpert_h

#include "const.h"
#include "type.h"
#include "StringModuleMember.h"

/*
#include "Matrix3DRotoTraslation.h"
#include "Param3DRotoTraslation.h"
#include <InverseMatrixCorrection.h>
#include "MatrixFunctions.h"
*/

#include <opencv/cxtypes.h>
#include <opencv/cv.h>
#include <opencv/cvaux.h>
#include <opencv/highgui.h>

#include <jpeglib.h>
#include <setjmp.h>

/*
#undef INC_ART //questo serve altrimenti non compila!! le artoolkitplus sono un po' scritte con il ...
#include "ARToolKitWrapper.h"

#include "VideoAcquisitionWheelchair.h"
#include "FireIAcquisition.h"
#include "FileRawAcquisition.h"
#include "GestioneConfigurazione.h"
#include "GestioneCoordinateAssolute.h"*/


#include "Spykee.h"

//#define SAVEVIDEO

using namespace std;

class VisionExpert : public StringModuleMember{
public:
	VisionExpert (ModuleDispatch* kernel, int period, Spykee *s, bool simFileCamera=false,string prefix="img",string postfix="",string format="%10d");
	~VisionExpert ();
	void RunInit();
	void RunClose();
	void RunDuty();
	bool isReady();
private:
	void TrackColor( IplImage *image );
	CvHistogram *CreateMatchingHist( string file );
	CvScalar hsv2rgb( float hue );
	void DrawHist( CvHistogram *hist, IplImage *image );
	unsigned char *jpeg2bmp( unsigned char *jpeg, int len );

	void AddBrianData( char *name, float value, float rel );

	static void my_error_exit( j_common_ptr cinfo );

	bool verifyPresence( int current );


	struct timeval 	tstart;
	Spykee *spykee;

	unsigned char *m_pBmpBuffer;

	CvHistogram *m_hist;
	IplImage *m_image;
	IplImage *m_hsv;
	IplImage *m_hue;
	IplImage *m_backProject;
	IplImage *m_mask;
	IplImage *m_debug;

	CvRect search_area;

	CvMat *m_colArr;
	CvMat *m_posArr;

#ifdef SAVEVIDEO
	CvVideoWriter *m_imgWriter;
	CvVideoWriter *m_bpWriter;
#endif

	int m_lastCount[10];
	
	weightfloat posx_array[POSITIONFILTER];
	weightfloat posy_array[POSITIONFILTER];
	weightfloat posa_array[POSITIONFILTER];
};
#endif
