#ifndef WiimExpert_h
#define WiimExpert_h

#include "StringModuleMember.h"

#include <sys/time.h>
#include <stdlib.h> 
#include <stdio.h>
#include <const.h>
#include <msg.h>
#include <wiim.h>
#include <wiiuse.h>
#include <Spykee.h>
#include <SonarExpert.h>

class WiimExpert : public StringModuleMember
{
	 	public:
  		WiimExpert (ModuleDispatch* kernel, int period, Spykee*, SonarExpert*);
  		~WiimExpert ();
   		void RunInit();
   		void RunClose();
   		void RunDuty();
   		void setRotDirection(int dir);

 		private:
   		Wiim* wiim;
   		int canDo();
   		void calculateposition();
   		long elapsed(int);
   		void settimer(int);
   		void AddBrianData(char*,float,float);
   		void printstatus();
   			
   		struct timeval last_render[11];
		int m_oldLeft;
		int m_oldRight;
   		float charged;
		int Hit;
		int gHome;
		int restartflag;
		int rotflag;
		int fps;
		int random_sign;

   		pos home;
   		pos goal;
   		pos center;
   		pos rob;
   		int angoloOdo;
   		
   		ppoint position;

		int robotpoint;
		int humanpoint;
		int pointrobotflag;
		
		float maxx,maxy,minx,miny;
		
		weightfloat ir_centerarray_x[IRCENTERFILTER];
		weightfloat ir_centerarray_y[IRCENTERFILTER];
		
		float base_time;
		FILE* fp;
		FILE* f;
		
		bool playing;
		int clock;

		Spykee* spykee;
		SonarExpert* sonar;

	};
#endif
